
Global CamSpeed = 1.2 , CamMode = 0 , RenderMode = 0, FullScreen = 0
Global KeyX, KeyY, RollZ, RotX, RotY, MouseX, MouseY, FPS, VSync = 1
Global xa,ya,za, cubeSize = 2, Ground = 1 , tilesize = 64

Declare InitWorld()
Declare Keyboard()
Declare LoadBuilding(filename.s)
Declare CreateCubes()
Declare ErrorHandler()

Enumeration
 #i0
 #i1
 #i2
 #i3
 #i4
 #i5
 #t0
 #t1
 #t2
 #t3
 #t4
 #t5
 #m1
 #m2
 #m3
 #m4
 #m5
EndEnumeration

Procedure InitWorld()
  
If Not InitEngine3D(#PB_Engine3D_NoLog) : End : EndIf
InitSprite()
InitKeyboard()
InitMouse()

UsePNGImageDecoder()
;UseJPEGImageDecoder()

Add3DArchive("\", #PB_3DArchive_FileSystem) 
AntialiasingMode(#PB_AntialiasingMode_x6)
;Parse3DScripts()

If Not FullScreen
  OpenWindow(0,0,0,800,600,"Preview3D",#PB_Window_SystemMenu|#PB_Window_ScreenCentered) 
  OpenWindowedScreen(WindowID(0),0,0,800,600,0,0,0,VSync) 
 Else
  ExamineDesktops()
  OpenScreen(DesktopWidth(0),DesktopHeight(0),32,"",VSync)
EndIf

CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, -30, 30,-40,#PB_Absolute)
RotateCamera(0,-90,0, 180)
CameraBackColor(0, $382423)

lx = -20 : ly = ya*cubesize+10 : lz = 0;za * cubesize+10 
;CreateSphere(99,1) : CreateEntity(99,MeshID(99),#PB_Material_None,lz,ly,lx)
CreateLight(0,$FFFFFF,lz,ly,lx,#PB_Light_Point)
;SpotLightRange(0,30, 90, -4) : LightLookAt(0,0,0,0)
;AmbientColor($FFFFFF)

CatchImage(#i0, ?i0) 
CreateTexture(#t0, tilesize, tilesize)
StartDrawing(TextureOutput(#t0))
DrawImage(ImageID(#i0),0,0)
StopDrawing()
CreateMaterial(0, TextureID(#t0))
CreatePlane(0, xa*cubesize+10, ya*cubesize+10, 50, 50, xa, ya)
CreateEntity(0,MeshID(0), MaterialID(0), 0, 0, 0)

CameraLookAt(0,EntityX(0),EntityY(0),EntityZ(0))

EndProcedure

Procedure Keyboard()
  
ExamineKeyboard()
     
If KeyboardPushed(#PB_Key_A)
  keyx = -1
 ElseIf KeyboardPushed(#PB_Key_D)
   keyx = 1 
 Else
  keyx = 0
EndIf

If KeyboardReleased(#PB_Key_A)
 
ElseIf KeyboardReleased(#PB_Key_D)
 
EndIf

If KeyboardPushed(#PB_Key_W)
  keyy = -1 
ElseIf KeyboardPushed(#PB_Key_S)
  keyy = 1 
Else
  keyy = 0
EndIf

If KeyboardReleased(#PB_Key_PageUp)
  rollz = 1 
ElseIf KeyboardReleased(#PB_Key_PageDown)
 rollz = 0
EndIf

If KeyboardReleased(#PB_Key_Space)
 
EndIf

If KeyboardReleased(#PB_Key_F1)
 MoveCamera(0, -30, 30,-40,#PB_Absolute)
 CameraLookAt(0,EntityX(0),EntityY(0),EntityZ(0))
 ;RotateCamera(0,-90,0, 180)
EndIf

If KeyboardReleased(#PB_Key_F2) 
 Rendermode = Rendermode + 1 
 Select Rendermode
   Case 0 : CameraRenderMode(0, #PB_Camera_Textured)
   Case 1 : CameraRenderMode(0, #PB_Camera_Wireframe)
   Case 2 : CameraRenderMode(0, #PB_Camera_Plot)
 EndSelect
 If Rendermode = 2 : Rendermode = -1 : EndIf
EndIf
 
 If KeyboardReleased(#PB_Key_F3)
   ;If CamMode = #True : CamMode = #False : Else : CamMode = #True : EndIf
 EndIf
      
ExamineMouse()
     
rotx = 0 : roty = 0
mousex = -MouseDeltaX()
mousey = -MouseDeltaY()
     
; If MouseButton(#PB_MouseButton_Right)
;  rotx = mousey
;  roty = mousex
;  mousex = 0
;  mousey = 0
; EndIf
     
EndProcedure

Procedure LoadBuilding(filename.s)
  
 File$ = filename
 ;File$ = OpenFileRequester("Load Building ", GetCurrentDirectory() , "txt (*.txt) | *.txt", 0)
 
 If ReadFile(0, File$) 
   
  MapSize$ = ReadString(0)  
  Dummy$   = ReadString(0)
  xa = Val(StringField(MapSize$, 1, "x"))    
  ya = Val(StringField(MapSize$, 2, "x"))     
  za = Val(StringField(MapSize$, 3, "x"))     
  
  Global Dim MapArray(xa, ya, za) 
  
  While ii < za + 1    
  Layer$ = ReadString(0) 
  Repeat
    iy + 1
    line$ = ReadString(0)
    If Line$ = Chr(10) Or Len(Line$) <> xa
      iy = 0 : ii + 1
      Break 
    Else
     For ix = 1 To Len(Line$) 
       Select Mid(Line$,ix,1)
       Case " "
       MapArray(ix,iy,ii) = 0 
       Case "#"
       MapArray(ix,iy,ii) = 0     
       Case "D"
       MapArray(ix,iy,ii) = 1
       Case "W"
       MapArray(ix,iy,ii) = 2 
       Case "L"
       MapArray(ix,iy,ii) = 3 
       Case "T"
       MapArray(ix,iy,ii) = 4 
       Case "G"
       MapArray(ix,iy,ii) = 5
       EndSelect
     Next ix
   EndIf  
 ForEver
 Wend
  CloseFile(0)             
 Else
  ProcedureReturn
   ;MessageRequester("Error","Could Not Open File !")
   Debug "FileError"
 EndIf

EndProcedure

Procedure CreateCubes()

CatchImage(#i1, ?i1)
CatchImage(#i2, ?i2)
CatchImage(#i3, ?i3)
CatchImage(#i4, ?i4)
CatchImage(#i5, ?i5)

CreateTexture(#t1, tilesize, tilesize)
CreateTexture(#t2, tilesize, tilesize)
CreateTexture(#t3, tilesize, tilesize)
CreateTexture(#t4, tilesize, tilesize)
CreateTexture(#t5, tilesize, tilesize)

StartDrawing(TextureOutput(#t1))
DrawImage(ImageID(#i1),0,0)
StopDrawing()
StartDrawing(TextureOutput(#t2))
DrawImage(ImageID(#i2),0,0)
StopDrawing()
StartDrawing(TextureOutput(#t3))
DrawImage(ImageID(#i3),0,0)
StopDrawing()
StartDrawing(TextureOutput(#t4))
DrawImage(ImageID(#i4),0,0)
StopDrawing()
StartDrawing(TextureOutput(#t5))
DrawImage(ImageID(#i5),0,0)
StopDrawing()

CreateMaterial(#m1,TextureID(#t1))
CreateMaterial(#m2,TextureID(#t2))
CreateMaterial(#m3,TextureID(#t3))
CreateMaterial(#m4,TextureID(#t4))
CreateMaterial(#m5,TextureID(#t5))
MaterialBlendingMode(#m5, #PB_Material_Add)

CreateCube(1,cubeSize)

CreateEntity(1, MeshID(1),MaterialID(#m1))
CreateEntity(2, MeshID(1),MaterialID(#m2))
CreateEntity(3, MeshID(1),MaterialID(#m3))
CreateEntity(4, MeshID(1),MaterialID(#m4))
CreateEntity(5, MeshID(1),MaterialID(#m5))

  
CreateStaticGeometry(0, xa * cubeSize, ya * cubeSize, (za+1) * cubeSize, 0) 
 
 For z = 0 To za  
  For y = 1 To ya
   For x = 1 To xa
    id = MapArray(x,y,z)
    xm = (x * cubeSize) - (xa * cubeSize / 2)
    ym = (y * cubeSize) - (ya * cubeSize / 2)
    zm = (z * cubeSize) + Ground
    ;If Not id = 0 : AddStaticGeometryEntity(0, EntityID(id), xm, zm, ym) : EndIf
    If Not id = 0 
    If id = 4
    AddStaticGeometryEntity(0, EntityID(id), xm, zm, ym,0.2,0.8,0.2)
    Else
    AddStaticGeometryEntity(0, EntityID(id), xm, zm, ym)
    EndIf
    EndIf
   Next x
  Next y
 Next z
 
 BuildStaticGeometry(0)
 
 FreeEntity(1)
 FreeEntity(2)
 FreeEntity(3)
 FreeEntity(4)
 FreeEntity(5)

EndProcedure

Procedure ErrorHandler()
 
 ;//////////////////////////////////////// Errorhandler : gibt eine Fehlermeldung aus und beendet das Programm //////////////////////////////////
 
 errormessage.s = ErrorMessage()
 MessageRequester("Error", errormessage + " Line: " +  Str(ErrorLine()))
 End
   
EndProcedure


OnErrorCall(@ErrorHandler())
LoadBuilding(ProgramParameter())
;LoadBuilding("house.txt")
InitWorld()
CreateCubes()

Repeat  
  
 If Not Fullscreen
 Select WaitWindowEvent(1) 
 Case #PB_Event_CloseWindow 
 Quit = #True 
 EndSelect 
 EndIf
 
 Keyboard()
 RotateEntity(0, 0, 0, rotx, #PB_Relative)
  
 RotateCamera(0, mousey, mousex, 0,#PB_Relative)
 MoveCamera  (0, keyx*CamSpeed, 0, keyy*CamSpeed)  

 FPS = Engine3DFrameRate(#PB_Engine3D_Current)
 RenderWorld() 
 
 FlipBuffers()
 
Until KeyboardPushed(#PB_Key_Escape) Or Quit = #True



DataSection
 i0:
 IncludeBinary "block0.png"
 i1:
 IncludeBinary "block1.png"
 i2:
 IncludeBinary "block2.png"
 i3:
 IncludeBinary "block3.png"
 i4:
 IncludeBinary "block4.png"
 i5:
 IncludeBinary "block5.png"
EndDataSection

; IDE Options = PureBasic 5.10 Beta 3 (Windows - x86)
; CursorPosition = 144
; FirstLine = 108
; Folding = -
; EnableXP
; EnableOnError
; UseIcon = icon.ico
; Executable = 3DPreview.exe