
XIncludeFile "ComboEx.pbi"

Enumeration
  #Window
  #ScrollArea
  #Canvas
  #Button_Load
  #Button_Save
  #Button_Create
  #Spin1
  #Spin2
  #Spin3
  #Spin4
  #ComboBox_Blocks
  #Sprite
  #Air
  #Base
  #RedBlock
  #Menu
EndEnumeration

Declare OpenWin()
Declare EmptyCanvas()
Declare DrawCanvas(mx,my)
Declare SetBlock()
Declare UpdateLayer()
Declare SaveBuilding(temp)
Declare LoadBuilding()
Declare PopUpMenu()
Declare DuplicateLayer(L1, L2)
Declare InsertLayer()
Declare RemoveLayer()
Declare ClearArray(xa, ya, za)
Declare Maximize(windowid, message, wparam, lparam)
Declare ButtonProc(hWnd, msg, wparam, lparam)
Declare FrontView()
Declare NormalView()
Declare ExtrudeFront()
Declare DrawLine(xstart,ystart,xend,yend)
Declare FillAreal()
Declare DrawSilhouette()
Declare RotateBuilding(angle)
Declare RotateLayer(layer, angle)
Declare Errorhandler()
Declare.l RotateImage(source,angle.f,scale)

Global Event, ToolSize = 90, Wheel 
Global xa,ya,za, xs, ys, FrontMode, TabMode ;Grsse des Arrays
Global mx,my, LastNV, LastFV ;MousePosition
Global OldLayer ;Beschleuning Layerwechsel

Procedure OpenWin()
  
  ;Gadgets erstellen
  
  If OpenWindow(#Window, 0, 0, 938, 740, "CreepyBlocks  0/0  Length: 0", #PB_Window_SystemMenu|#PB_Window_MinimizeGadget| #PB_Window_MaximizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
   ButtonGadget(#Button_Load, 10, 20, 80, 30, "Load")
   ButtonGadget(#Button_Save, 110, 20, 80, 30, "Save")
   SpinGadget(#Spin1, 210, 20, 80, 30, 1, 1000, #PB_Spin_Numeric) : SetGadgetText(#Spin1, "29")
   SpinGadget(#Spin2, 300, 20, 80, 30, 1, 1000, #PB_Spin_Numeric) : SetGadgetText(#Spin2, "20")
   SpinGadget(#Spin3, 390, 20, 70, 30, 1, 1000, #PB_Spin_Numeric) : SetGadgetText(#Spin3, "18")
   SpinGadget(#Spin4, 660, 16, 60, 45, 0, 1000, #PB_Spin_Numeric) : SetGadgetText(#Spin4, "8")
   ButtonGadget(#Button_Create, 480, 20, 90, 31, "New")
   ComboBoxExGadget(#ComboBox_Blocks, 755, 18,170, 332, 0, 32, 32)
   ScrollAreaGadget(#ScrollArea, 0, 70, 960, 660, 956, 744, 10, #PB_ScrollArea_Raised)
   CanvasGadget(#Canvas, 0, 70, 960, 660,#PB_Canvas_Border | #PB_Canvas_Keyboard |#PB_Canvas_DrawFocus)
   CloseGadgetList()
  EndIf
  
  ;Shortcuts und PopupMen erstellen
  
  ;WASD
  AddKeyboardShortcut(#Window, #PB_Shortcut_W, 20)
  AddKeyboardShortcut(#Window, #PB_Shortcut_A, 21)
  AddKeyboardShortcut(#Window, #PB_Shortcut_S, 22)
  AddKeyboardShortcut(#Window, #PB_Shortcut_D, 23)
  
  AddKeyboardShortcut(#Window, #PB_Shortcut_Control | #PB_Shortcut_D, 15)
  AddKeyboardShortcut(#Window, #PB_Shortcut_Tab, 7)
  AddKeyboardShortcut(#Window, #PB_Shortcut_Control | #PB_Shortcut_R, 16)
  AddKeyboardShortcut(#Window, #PB_Shortcut_Alt, 17)
;   AddKeyboardShortcut(#Window, #PB_Shortcut_C, 18)
;   AddKeyboardShortcut(#Window, #PB_Shortcut_V, 19)
;   AddKeyboardShortcut(#Window, #PB_Shortcut_F, 24)
  
  CreatePopupMenu(#Menu)     
  MenuItem(1, "Copy Layer")     
  MenuItem(2, "Paste Layer")
  MenuItem(3, "Insert Layer")      
  MenuItem(4, "Remove Layer")
  MenuItem(5, "Fill Area")
  MenuItem(6, "Silhouette")
  MenuItem(7, "FrontView")
  MenuItem(8, "Preview 3D")
  
  CloseSubMenu()
  
  ;Font laden und setzen
  LoadFont(0,"Arial",12)
  SetGadgetFont(#Button_Load,FontID(0))
  SetGadgetFont(#Button_Save,FontID(0))
  SetGadgetFont(#Button_Create,FontID(0))
  
  SetGadgetFont(#Spin1,FontID(0))
  SetGadgetFont(#Spin2,FontID(0))
  SetGadgetFont(#Spin3,FontID(0))
  SetGadgetFont(#Spin4,FontID(0))
  
  SetWindowCallback(@Maximize())
  
  UsePNGImageDecoder() : CatchImage(#Sprite, ?Terrain) : Global NewList BlockImages.l()
  SpriteX = ImageWidth(#Sprite) / 16 : SpriteY = ImageHeight(#Sprite) / 16
  
  ;BlockListe
  Global Dim Stuff.s(6)
  Stuff(0) = "Air"
  Stuff(1) = "Base"
  Stuff(2) = "Dirt"
  Stuff(3) = "Wood"
  Stuff(4) = "Logs"
  Stuff(5) = "Torch"
  Stuff(6) = "Glass"
  
  ;Air und Base erstellen
  CatchImage(#Air,  ?Air)
  ResizeImage(#Air, 32,32,32)
  AddElement(BlockImages()) : BlockImages() = ImageID(#Air)
  AddGadgetItem(#ComboBox_Blocks, -1 , "Air" , ImageID(#Air))
  
  CatchImage(#Base, ?Base)
  ResizeImage(#Base, 32,32,32)
  AddElement(BlockImages()) : BlockImages() = ImageID(#Base)
  AddGadgetItem(#ComboBox_Blocks, -1 , "Base" , ImageID(#Base))
  
  SetGadgetState(#ComboBox_Blocks, 0)
  
  ;Blocks grabben und ComboBox Liste erstellen
  ci = 1
   For iy = 0 To SpriteY -1
   For ix = 0 To SpriteX -1
    AddElement(BlockImages())
    buf=GrabImage(#Sprite, #PB_Any, ix * 16, iy * 16, 16 , 16)
    ResizeImage(buf, 32,32,32)
    BlockImages() = ImageID(buf) : ci+1
    AddGadgetItem(#ComboBox_Blocks, -1 , Stuff(ci) , BlockImages())
   Next ix
  Next iy
  
  ;Roter Block erstellen
  CatchImage(#RedBlock, ?Red)
   
EndProcedure


Procedure EmptyCanvas()
 
 ;Array erstellen und Grsse berechnen
 xa = GetGadgetState(#Spin1)
 ya = GetGadgetState(#Spin2)
 za = GetGadgetState(#Spin3) 
 
 Global Dim MapArray(xa, ya, za)
 Global Dim FrontArray(ya, za+1)
 
 xs = xa * ImageWidth(#Air)  + 5
 ys = ya * ImageHeight(#Air) + 5

 ;Gadgets an Grsse ausrichten
 ScrollAreaGadget(#ScrollArea, 0, ToolSize, WindowWidth(#Window), WindowHeight(#Window)-ToolSize, xs, ys, #PB_ScrollArea_Raised)
 CanvasGadget(#Canvas, 0, 0, xs, ys, #PB_Canvas_Border)
 CloseGadgetList()
 
 ;Array leeren
 ClearArray(xa,ya,za)
 
 ;Canvas malen
 StartDrawing(CanvasOutput(#Canvas))
 For iy = 0 To ya-1
   For ix = 0 To xa-1
    SelectElement(BlockImages(),1)
    DrawImage(BlockImages(),ix * ImageWidth(#Air), iy * ImageHeight(#Air)) 
   Next ix
  Next iy
 DrawText(5,5,"NormalView",$444444,$A1A1A1)
 StopDrawing()
 
 ;Min und Max Attribute setzen
 SetGadgetAttribute(#Spin4, #PB_Spin_Minimum, 0) 
 SetGadgetAttribute(#Spin4, #PB_Spin_Maximum, za)
 SetGadgetState(#Spin4,0)
 SetGadgetState(#ComboBox_Blocks,2)
 
 FrontMode = 0
 LastNV = 0 : LastFV = 1
 SetMenuItemText(#Menu, 7, "FrontView")
 ;NormalView()
 
EndProcedure


Procedure DrawCanvas(mx,my)
 
 ;auf Canvas an Mausposition malen (mx,my)
 StartDrawing(CanvasOutput(#Canvas)) 
 
 If Not FrontMode ;NormalView
  ;StartDrawing(CanvasOutput(#Canvas)) 
  lay = GetGadgetState(#Spin4)
  SelectElement(BlockImages(), MapArray(mx,my,lay))
  DrawImage(BlockImages(),((mx-1) * ImageWidth(#Air)), ((my-1) * ImageHeight(#Air)))
  ;StopDrawing()
  
 ElseIf FrontMode ;FrontMode 
  ;StartDrawing(CanvasOutput(#Canvas)) 
  SelectElement(BlockImages(), FrontArray(mx,my))
  DrawImage(BlockImages(),((mx-1) * ImageWidth(#Air)), ((my-1) * ImageHeight(#Air)))
  ;StopDrawing()
 EndIf 
 
 StopDrawing()
 
EndProcedure


Procedure SetBlock()
 
 Static oldx,oldy, tit$ 
 Static lx1,ly1,lx2,ly2,ll, dx,dy
 SetActiveGadget(#ScrollArea)
 
 ;TilePosition und Lnge anzeigen 
 SetWindowTitle(#Window, "Creepy Blocks  " + Str(mx) + "/" + Str(my) + tit$)
 

 If Not FrontMode   
   
   ;Mausposition auf Canvas berechnen  
   mx = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseX)  / ImageWidth(#Air)  +1) 
   my = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseY)  / ImageHeight(#Air) +1)
   If my = oldy : tit$ = "  Length: " + Str(mx-oldx+1) : Else : tit$ = "  Length: " + Str(my-oldy+1) : EndIf; Lnge berechnen
  
   ;STR+LeftClick
  If GetGadgetAttribute(#Canvas, #PB_Canvas_Modifiers) & #PB_Canvas_Control And EventType() = #PB_EventType_LeftButtonDown 
   If Not (mx < 0 Or mx > xa Or my < 0 Or my > ya)
    lay = GetGadgetState(#Spin4)
    block = MapArray(mx,my,lay) 
    SetGadgetState(#ComboBox_Blocks,block)
    SetActiveGadget(#ScrollArea)
    ProcedureReturn
    EndIf
  EndIf  
  
   ;Shift+LeftClickUp (Draw a Line)
  If GetGadgetAttribute(#Canvas, #PB_Canvas_Modifiers) & #PB_Canvas_Shift And EventType() = #PB_EventType_LeftButtonDown
   If Not (mx < 0 Or mx > xa Or my < 0 Or my > ya)
     If ll = 0 : lx1 = mx : ly1 = my : ll = 1 : ProcedureReturn : EndIf
     If ll = 1 : lx2 = mx : ly2 = my : DrawLine(lx1,ly1,lx2,ly2)  : ll = 0 : EndIf
     ProcedureReturn
    EndIf
  EndIf  
  
 
  ;LeftClick          
 If (EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Canvas, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)) And
 Not (GetGadgetAttribute(#Canvas, #PB_Canvas_Modifiers) & #PB_Canvas_Alt)
  
  If Not (mx < 0 Or mx > xa Or my < 0 Or my > ya)
  lay   = GetGadgetState(#Spin4)
  block = GetGadgetState(#ComboBox_Blocks) 
  MapArray(mx,my,lay) = block
  ;UpdateLayer()
  DrawCanvas(mx,my)
  OldX = mx : OldY = my
  EndIf
 EndIf
 
   ;RightClick
 If EventType() = #PB_EventType_RightButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Canvas, #PB_Canvas_Buttons) & #PB_Canvas_RightButton) And
 Not (GetGadgetAttribute(#Canvas, #PB_Canvas_Modifiers) & #PB_Canvas_Alt)
  mx = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseX)  / ImageWidth(#Air)  +1) 
  my = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseY)  / ImageHeight(#Air) +1)
  If Not (mx < 0 Or mx > xa Or my < 0 Or my > ya)
  lay   = GetGadgetState(#Spin4)
  If lay = 0 : block = 1 : Else : block = 0 : EndIf
  MapArray(mx,my,lay) = block
  ;UpdateLayer()
  DrawCanvas(mx,my)
  EndIf
 EndIf
 
   ;ALT+LeftClick          
 If (EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Canvas, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)) And 
    (GetGadgetAttribute(#Canvas, #PB_Canvas_Modifiers) & #PB_Canvas_Alt)
  If Not (mx < 0 Or mx > xa Or my < 0 Or my > ya)
  lay   = GetGadgetState(#Spin4)
  block = GetGadgetState(#ComboBox_Blocks) 
  For i = lay To 0 Step -1
  MapArray(mx,my,i) = block
  Next i
  ;UpdateLayer()
  DrawCanvas(mx,my)
  OldX = mx : OldY = my
  EndIf
 EndIf
   
    ;ALT+RightClick          
  If (EventType() = #PB_EventType_RightButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Canvas, #PB_Canvas_Buttons) & #PB_Canvas_RightButton)) And
   (GetGadgetAttribute(#Canvas, #PB_Canvas_Modifiers) & #PB_Canvas_Alt)
  mx = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseX)  / ImageWidth(#Air)  +1) 
  my = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseY)  / ImageHeight(#Air) +1)
  If Not (mx < 0 Or mx > xa Or my < 0 Or my > ya)
  lay   = GetGadgetState(#Spin4)
  If lay = 0 : block = 1 : Else : block = 0 : EndIf
  For i = lay To 0 Step -1
  MapArray(mx,my,i) = block
  Next i
  ;UpdateLayer()
  DrawCanvas(mx,my)
  EndIf
 EndIf
  
 ElseIf FrontMode
 
 TabMode = 0 ; TabModus im FrontMode ausschalten
 
 ;Mausposition auf Canvas berechnen
 mx = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseX)  / ImageWidth(#Air)) + 1 
 my = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseY)  / ImageHeight(#Air))
 
 ;CTRL+LeftClick
 If (GetGadgetAttribute(#Canvas, #PB_Canvas_Modifiers) & #PB_Canvas_Control And EventType() = #PB_EventType_LeftButtonDown) Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Canvas, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton And GetGadgetAttribute(#Canvas, #PB_Canvas_Modifiers) & #PB_Canvas_Control)
  If Not (mx < 1 Or mx > ya Or my < 0 Or my > za)
    block = MapArray(GetGadgetState(#Spin4), mx,za-my)
    SetGadgetState(#ComboBox_Blocks,block)
    SetActiveGadget(#ScrollArea)
    ProcedureReturn
    EndIf
  EndIf  
 
 ;LeftClick                 
 If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Canvas, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
  If Not (mx < 1 Or mx > ya Or my < 0 Or my > za)
  block = GetGadgetState(#ComboBox_Blocks) 
  FrontArray(mx,my+1) = block
  DrawCanvas(mx,my+1)
  OldX = mx : OldY = my
  MapArray(GetGadgetState(#Spin4), mx,za-my) = block
  EndIf
 EndIf
 
 ;RightClick
 If EventType() = #PB_EventType_RightButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Canvas, #PB_Canvas_Buttons) & #PB_Canvas_RightButton)
  If Not (mx < 1 Or mx > ya Or my < 0 Or my > za)
   FrontArray(mx,my+1) = 0
   If my = za 
   MapArray(GetGadgetState(#Spin4), mx,za-my) = 1 
   Else
   MapArray(GetGadgetState(#Spin4), mx,za-my) = 0
   EndIf 
   DrawCanvas(mx,my+1)
  EndIf
 EndIf

 EndIf
 
EndProcedure  


Procedure UpdateLayer()

;gesamte Canvas neuzeichnen
StartDrawing(CanvasOutput(#Canvas))

If Not FrontMode

 ;alten Layer lschen
 For iy = 0 To ya-1
 For ix = 0 To xa-1
 If MapArray(ix+1,iy+1,OldLayer) > 1 
 If OldLayer = 0 
 SelectElement(BlockImages(),1)
 DrawImage(BlockImages(),ix * ImageWidth(#Air), iy * ImageHeight(#Air)) 
 ElseIf OldLayer > 0
 SelectElement(BlockImages(),0)
 DrawImage(BlockImages(),ix * ImageWidth(#Air), iy * ImageHeight(#Air))
 EndIf
 EndIf
 Next ix
 Next iy  
 ;StopDrawing()
 
 DrawSilhouette()
 
 ;Neuer Layer
 ;StartDrawing(CanvasOutput(#Canvas))
 Layer=GetGadgetState(#Spin4)
 For iy = 0 To ya-1
   For ix = 0 To xa-1
     If MapArray(ix+1,iy+1,layer) > 1 
     SelectElement(BlockImages(), MapArray(ix+1,iy+1,Layer))
      DrawImage(BlockImages(),ix * ImageWidth(#Air), iy * ImageHeight(#Air)) 
     EndIf
   Next ix
 Next iy
 DrawText(5,5,"NormalView",$444444,$A1A1A1)
 SetActiveGadget(#ScrollArea)

ElseIf FrontMode;
  Layer=GetGadgetState(#Spin4)
  For iz = 0 To za
    For iy = 0 To ya-1 
     SelectElement(BlockImages(), MapArray(Layer, iy+1,(za)-iz))
     DrawImage(BlockImages(), iy * ImageWidth(#Air), iz * ImageHeight(#Air))
    Next iy
  Next iz
 DrawText(5,5,"FrontView",$444444,$A1A1A1)
 
 SetActiveGadget(#ScrollArea)
 
EndIf

StopDrawing()
   
EndProcedure


Procedure LoadBuilding()
  
 File$ = OpenFileRequester("Load Building ", GetCurrentDirectory() , "txt (*.txt) | *.txt", 0)
 
 If ReadFile(0, File$) 
  
  ; Grsse des Arrays einlesen 
  MapSize$ = ReadString(0)  
  Dummy$   = ReadString(0)
  xa = Val(StringField(MapSize$, 1, "x"))     : SetGadgetText(#Spin1, Str(xa))
  ya = Val(StringField(MapSize$, 2, "x"))     : SetGadgetText(#Spin2, Str(ya))
  za = Val(StringField(MapSize$, 3, "x"))     : SetGadgetText(#Spin3, Str(za))
  
  Global Dim MapArray(xa, ya, za) 
  
  ;ArrayWerte setzen
  While ii < za + 1       
  Layer$ = ReadString(0) 
  Repeat
    iy + 1
    line$ = ReadString(0)
    If Line$ = Chr(10) Or Len(Line$) <> xa
      iy = 0 : ii + 1
      Break 
    Else
     For ix = 1 To Len(Line$) 
       Select Mid(Line$,ix,1)
       Case "D"
       MapArray(ix,iy,ii) = 2
       Case "W"
       MapArray(ix,iy,ii) = 3 
       Case "L"
       MapArray(ix,iy,ii) = 4 
       Case "T"
       MapArray(ix,iy,ii) = 5 
       Case "G"
       MapArray(ix,iy,ii) = 6
       Case " "
       MapArray(ix,iy,ii) = 0 
       Case "#"
       MapArray(ix,iy,ii) = 1     
       EndSelect
     Next ix
   EndIf  
 ForEver
 Wend
  CloseFile(0)             
 Else
  ProcedureReturn
  ;MessageRequester("Error","Could Not Open File !")
 EndIf

;Grsse berechnen 
xs = xa * ImageWidth(#Air)  + 5 
ys = ya * ImageHeight(#Air) + 5

;Gadgets an Grsse anpassen 
ScrollAreaGadget(#ScrollArea, 0, ToolSize, WindowWidth(#Window), WindowHeight(#Window)-ToolSize, xs, ys, #PB_ScrollArea_Raised)
CanvasGadget(#Canvas, 0, 0, xs, ys, #PB_Canvas_Border) 
CloseGadgetList()

;SpinGadget Maximum anpassen
LastNV = 0 : LastFV = 1
SetGadgetAttribute(#Spin4, #PB_Spin_Maximum, za) : SetGadgetState(#Spin4,0)
FrontMode = 0 : NormalView() ; NormalView nach laden setzen
UpdateLayer() ; Canvas updaten


EndProcedure


Procedure SaveBuilding(temp)
  
   
 If Not temp ; FileRequester ffnen, falls nicht 3D-Preview
 File$ = SaveFileRequester("Save Building ", GetCurrentDirectory() , "txt (*.txt) | *.txt", 1)
 If Not GetExtensionPart(File$) = "txt" : File$ = File$ + ".txt" : EndIf
 Else : File$ = "preview.tmp"
 EndIf
   
 If CreateFile(0, File$,#PB_File_NoBuffering)
 

 ;Datei Kopf schreiben
 MapSize$ = Str(xa) + "x" + Str(ya) + "x" + Str(za)
 WriteStringN(0, MapSize$)
 WriteStringN(0, "------")
 
 ;Werte aus Array lesen und in Datei schreiben
  While ii < za + 1    
   WriteStringN(0, "layer " + Str(ii))  
  Repeat
    iy + 1
    If iy > ya : iy = 0 : ii + 1 : WriteStringN(0,""): Break : EndIf
    For ix = 1 To xa 
      Select MapArray(ix,iy,ii)
       Case 0
       WriteAsciiCharacter(0, Asc(" "))
       Case 1
       WriteAsciiCharacter(0, Asc("#"))
       Case 2
       WriteAsciiCharacter(0, Asc("D"))
       Case 3
       WriteAsciiCharacter(0, Asc("W"))
       Case 4
       WriteAsciiCharacter(0, Asc("L"))  
       Case 5
       WriteAsciiCharacter(0, Asc("T")) 
       Case 6
       WriteAsciiCharacter(0, Asc("G"))  
       EndSelect
     Next ix
     WriteStringN(0,"")
    ForEver
 Wend

  CloseFile(0)             
 Else
  MessageRequester("Error","Could Not Open File !")
EndIf

EndProcedure


Procedure ClearArray(xa, ya, za)
 
 ;Array leeren bzw. in Layer 0 mit Base auffllen 
 For iz = 0 To za
  If iz = 0 : SelectElement(BlockImages(),1) : Else : SelectElement(BlockImages(),0) : EndIf
   For iy = 1 To ya
    For ix = 1 To xa
     MapArray(ix,iy,iz) = ListIndex(BlockImages()) 
    Next ix
  Next iy
 Next iz

EndProcedure


Procedure PopUpMenu()
  
Static L1 = -1,L2 = -1 
  
Select EventMenu()
  Case 1 ; erster Layer wird ausgewhlt
    If Not FrontMode
    L1 = GetGadgetState(#Spin4)
    ;L2 = -1
    EndIf
 Case 2 ; zweiter Layer wird ausgewhlt
   If Not FrontMode
   L2 = GetGadgetState(#Spin4)
   ;If Not L1 = -1 : DuplicateLayer(L1,L2) : UpdateLayer() : EndIf
   DuplicateLayer(L1,L2) : UpdateLayer() 
   EndIf
 Case 3;AddLayer
   InsertLayer()
 Case 4;Remove Layer
   RemoveLayer()
 Case 5 ; Fllfunktion
   FillAreal()
 Case 6 ; TabModus an/aus
  If Not FrontMode
  If TabMode = 0
  TabMode = 1
  UpdateLayer(); updaten
  Else
  TabMode = 0
  UpdateLayer(); updaten
  EndIf
  EndIf
 Case 7 ;FrontView / NormalView
   If FrontMode = 0
    FrontMode = 1 
    LastNV = GetGadgetState(#Spin4)
    FrontView()
    Else
    FrontMode = 0
    LastFV = GetGadgetState(#Spin4)
    NormalView()
   EndIf
 Case 8 ;3D Preview
  SaveBuilding(1)
  RunProgram("3DPreview", "preview.tmp" , GetCurrentDirectory(), #PB_Program_Wait)
  DeleteFile("preview.tmp")
 Case 15 ;Str+D DuplicateLayer
  If Not FrontMode
  L1 = GetGadgetState(#Spin4)
  If Not L1 > za - 1
  L2 = L1+1
  DuplicateLayer(L1,L2)
  SetGadgetState(#Spin4,L2)
  ;L1 = -1 : L2 = -1
  UpdateLayer()
  EndIf
  ElseIf FrontMode
   DuplicateLayer(0,0)
  EndIf
 Case 16
  RotateBuilding(450)
 Case 18
  If Not FrontMode
  L1 = GetGadgetState(#Spin4)
  ;L2 = -1
  EndIf
 Case 19
  If Not FrontMode
  L2 = GetGadgetState(#Spin4)
  ;If Not L1 = -1 : DuplicateLayer(L1,L2) : UpdateLayer() : EndIf
  DuplicateLayer(L1,L2) : UpdateLayer() 
  EndIf
 Case 24
  FillAreal()
 Case 20
 SetGadgetAttribute(#ScrollArea, #PB_ScrollArea_Y, GetGadgetAttribute(#ScrollArea, #PB_ScrollArea_Y)-30) 
 Case 21
 SetGadgetAttribute(#ScrollArea, #PB_ScrollArea_X, GetGadgetAttribute(#ScrollArea, #PB_ScrollArea_X)-30) 
 Case 22
 SetGadgetAttribute(#ScrollArea, #PB_ScrollArea_Y, GetGadgetAttribute(#ScrollArea, #PB_ScrollArea_Y)+30) 
 Case 23
 SetGadgetAttribute(#ScrollArea, #PB_ScrollArea_X, GetGadgetAttribute(#ScrollArea, #PB_ScrollArea_X)+30)
 Case 24
 SetGadgetAttribute(#ScrollArea, #PB_ScrollArea_Y, GetGadgetAttribute(#ScrollArea, #PB_ScrollArea_Y)-30)
EndSelect

EndProcedure


Procedure DuplicateLayer(L1, L2)

If Not FrontMode
  
If (L1 And L2) <> 0 ;beide Layer vorhanden -> duplizieren
   
  For iy = 0 To ya
  For ix = 0 To xa
  MapArray(ix,iy,l2) = MapArray(ix, iy, l1)
  Next ix
  Next iy
ElseIf L1=0 And L2 > 0  ;L1 ist Baselayer (0 einfgen)
  For iy = 0 To ya
  For ix = 0 To xa
  Block = MapArray(ix, iy, l1)
  If block = 1 : Block = 0 : EndIf
  MapArray(ix,iy,l2) = block
  Next ix
  Next iy
ElseIf L1 > 0 And L2 = 0 ;L2 ist BaseLayer (# einfgen)
  For iy = 0 To ya
  For ix = 0 To xa
  block = MapArray(ix, iy, l1)
  If block = 0 : Block = 1 : EndIf
  MapArray(ix,iy,l2) = block
  Next ix
  Next iy
  
EndIf

;im Frontmode Layer extrudieren
ElseIf FrontMode
 If GetGadgetState(#Spin4) < GetGadgetAttribute(#Spin4, #PB_Spin_Maximum)
 ExtrudeFront()
 EndIf
EndIf


EndProcedure


Procedure FillAreal()


If Not FrontMode

;Layer + Block lesen
lay   = GetGadgetState(#Spin4)
SelectElement(BlockImages(),GetGadgetState(#ComboBox_Blocks))

;Fllfarbe festlegen
Select ListIndex(BlockImages())
 Case 0 : fill = $0
 Case 1 : fill = $45EA45
 Case 2 : fill = $003755
 Case 3 : fill = $71B6DA
 Case 4 : fill = $15394C
 Case 5 : fill = $00DBDE
 Case 6 : fill = $EAE045
EndSelect

;Bild erstellen 
Picture = CreateImage(#PB_Any, xa, ya)
StartDrawing(ImageOutput(Picture))

For y = 0 To ya-1
For x = 0 To xa-1
 Select MapArray(x+1,y+1,lay)
 Case 0 : Color = $0
 Case 1 : color = $45EA45
 Case 2 : color = $003755
 Case 3 : color = $71B6DA
 Case 4 : color = $15394C
 Case 5 : color = $00DBDE
 Case 6 : color = $EAE045
 EndSelect
 Plot(x,y,color)
Next x
Next y

;Flche fllen
FillArea(mx-1,my-1, -1 , fill) 

;Bildaten ins Array zurckkopieren
For y = 0 To ya-1
For x = 0 To xa-1
 Select Point(x,y)
 Case $0      : MapArray(x+1,y+1,lay) = 0
 Case $45EA45 : MapArray(x+1,y+1,lay) = 1
 Case $003755 : MapArray(x+1,y+1,lay) = 2
 Case $71B6DA : MapArray(x+1,y+1,lay) = 3
 Case $15394C : MapArray(x+1,y+1,lay) = 4
 Case $00DBDE : MapArray(x+1,y+1,lay) = 5
 Case $EAE045 : MapArray(x+1,y+1,lay) = 6
 EndSelect
Next x
Next y

StopDrawing()

;Updaten
FreeImage(Picture)
UpdateLayer()

ElseIf FrontMode

;Layer + Block lesen
lay   = GetGadgetState(#Spin4)
SelectElement(BlockImages(),GetGadgetState(#ComboBox_Blocks))

;Fllfarbe festlegen
Select ListIndex(BlockImages())
 Case 0 : fill = $0
 Case 1 : fill = $45EA45
 Case 2 : fill = $003755
 Case 3 : fill = $71B6DA
 Case 4 : fill = $15394C
 Case 5 : fill = $00DBDE
 Case 6 : fill = $EAE045
EndSelect

;Bild erstellen 
Picture = CreateImage(#PB_Any, ya, za+1)
StartDrawing(ImageOutput(Picture))

For z = 0 To za
For y = 0 To ya-1
 Select MapArray(lay, y+1,za-z) 
 Case 0 : Color = $0
 Case 1 : color = $45EA45
 Case 2 : color = $003755
 Case 3 : color = $71B6DA
 Case 4 : color = $15394C
 Case 5 : color = $00DBDE
 Case 6 : color = $EAE045
 EndSelect
 Plot(y,z,color)
Next y
Next z

;Flche fllen
FillArea(mx-1,my-1, -1 , fill) 

;Bildaten ins Array zurckkopieren
For z = za To 0 Step-1 
For y = 1 To ya
 Select Point(y-1,z)
 Case $0      : FrontArray(y,z+1) = 0 : MapArray(lay, y,(za-z)) = 0
 Case $45EA45 : FrontArray(y,z+1) = 1 : MapArray(lay, y,(za-z)) = 1
 Case $003755 : FrontArray(y,z+1) = 2 : MapArray(lay, y,(za-z)) = 2
 Case $71B6DA : FrontArray(y,z+1) = 3 : MapArray(lay, y,(za-z)) = 3
 Case $15394C : FrontArray(y,z+1) = 4 : MapArray(lay, y,(za-z)) = 4
 Case $00DBDE : FrontArray(y,z+1) = 5 : MapArray(lay, y,(za-z)) = 5
 Case $EAE045 : FrontArray(y,z+1) = 6 : MapArray(lay, y,(za-z)) = 6
 EndSelect
Next y
Next z

StopDrawing()
 
;Updaten
FreeImage(Picture)
UpdateLayer()

EndIf

EndProcedure


Procedure DrawSilhouette()

 ;Silhouette
 If TabMode = 1
 ;StartDrawing(CanvasOutput(#Canvas))
 Layer=GetGadgetState(#Spin4)
 If Layer > 0 
 For iy = 0 To ya-1
 For ix = 0 To xa-1
 If MapArray(ix+1,iy+1,Layer-1) > 1
 DrawImage(ImageID(#RedBlock),ix * ImageWidth(#RedBlock), iy * ImageHeight(#RedBlock))
 Else
 DrawImage(ImageID(#Air),ix * ImageWidth(#Air), iy * ImageHeight(#Air))
 EndIf
 Next ix
 Next iy
 EndIf
 ;StopDrawing()
 EndIf
 
EndProcedure


Procedure FrontView()

SetMenuItemText(#Menu, 7, "Normal View")

;Grsse neuberechnen
xs = ya * ImageWidth(#Air)  + 5
ys = (za+1) * ImageHeight(#Air) + 5

;Gadgets anpassen
ScrollAreaGadget(#ScrollArea, 0, ToolSize, WindowWidth(#Window), WindowHeight(#Window)-ToolSize, xs, ys, #PB_ScrollArea_Raised)
CanvasGadget(#Canvas, 0, 0, xs, ys, #PB_Canvas_Border)
 
CloseGadgetList()

;Min und Max Attribute setzen
SetGadgetAttribute(#Spin4, #PB_Spin_Minimum, 1)
SetGadgetAttribute(#Spin4, #PB_Spin_Maximum, xa)
SetGadgetState(#Spin4,LastFV)

;Canvas updaten
 StartDrawing(CanvasOutput(#Canvas)) : Layer=GetGadgetState(#Spin4)
 For iz = 0 To za
  For iy = 0 To ya-1 
   SelectElement(BlockImages(), MapArray(Layer, iy+1,(za)-iz))
   DrawImage(BlockImages(), iy * ImageWidth(#Air), iz * ImageHeight(#Air))
   Next iy
  Next iz
 StopDrawing()
 
EndProcedure


Procedure NormalView()
 
 ;Grsse neuberechnen
 xs = xa * ImageWidth(#Air)  + 5
 ys = ya * ImageHeight(#Air) + 5
 
 ;Gadgets anpassen
 ScrollAreaGadget(#ScrollArea, 0, ToolSize, WindowWidth(#Window), WindowHeight(#Window)-ToolSize, xs, ys, #PB_ScrollArea_Raised)
 CanvasGadget(#Canvas, 0, 0, xs, ys, #PB_Canvas_Border)
 CloseGadgetList()
 
 ;Min und Max Attribute setzen
 SetGadgetAttribute(#Spin4, #PB_Spin_Minimum, 0)
 SetGadgetAttribute(#Spin4, #PB_Spin_Maximum, za)
 SetGadgetState(#Spin4, LastNV)
 
 FrontMode = 0
 SetMenuItemText(#Menu, 7, "FrontView")
 
 ;Canvas updaten
 StartDrawing(CanvasOutput(#Canvas)) : Layer=GetGadgetState(#Spin4)
 For iy = 0 To ya-1
  For ix = 0 To xa-1
   SelectElement(BlockImages(), MapArray(ix+1,iy+1,Layer))
   DrawImage(BlockImages(),ix * ImageWidth(#Air), iy * ImageHeight(#Air)) 
 Next ix
 Next iy
 StopDrawing()
 
EndProcedure


Procedure ExtrudeFront()

lay = GetGadgetState(#Spin4) ; Layer lesen

For z = za+1 To 1 Step -1
 For y = 1 To ya
   b+1
   If Not FrontArray(y,z) = 0 Or FrontArray(y,z) = 1 : MapArray(lay+1,b,h) = FrontArray(y,z) : EndIf ; Achsen getauscht
  Next y
  b = 0
  h + 1
 Next z

SetGadgetState(#Spin4, GetGadgetState(#Spin4)+1)
UpdateLayer()

EndProcedure


Procedure DrawLine(xstart,ystart,xend,yend)
   

;  REM Bresenham-Algorithmus fr eine Linie in einem beliebigen Oktanten in Pseudo-Basic

  dx = xend-xstart
  dy = yend-ystart
  

  adx = Abs(dx): ady = Abs(dy)   ; Absolutbetraege Distanzen
  sdx = Sign(dx): sdy = Sign(dy) ; Signum Distanzen

  
  If adx > ady 
    ;x ist schnelle Richtung
    pdx = sdx : pdy = 0    ;pd. ist Parallelschritt
    ddx = sdx : ddy = sdy  ;dd. ist Diagonalschritt
    es  = ady : el  = adx  ;Fehlerschritte schnell, langsam
  Else
    ;y ist schnelle Richtung
    pdx = 0   : pdy = sdy  ;pd. ist Parallelschritt
    ddx = sdx : ddy = sdy  ;dd. ist Diagonalschritt
    es  = adx : el  = ady  ;Fehlerschritte schnell, langsam
  EndIf
  
  x = xstart
  y = ystart
  
  lay   = GetGadgetState(#Spin4)
  block = GetGadgetState(#ComboBox_Blocks) 
  MapArray(x,y,lay) = block
  ;DrawCanvas(x,y)
  
  fehler = el/2 
  
; REM Pixelschleife: immer ein Schritt in schnelle Richtung, hin und wieder auch einer in langsame
  For i=1 To el          ; el gibt auch Anzahl der zu zeichnenden Pixel an
   ;REM Aktualisierung Fehlerterm
     fehler = fehler - es
     If fehler < 0
      fehler = fehler + el  ;Fehlerterm wieder positiv (>=0) machen
      ;REM Schritt in langsame Richtung
        x = x + ddx: y = y + ddy  ;Diagonalschritt
     Else
      ;REM Schritt in schnelle Richtung
       x = x + pdx: y = y + pdy ;Parallelschritt
     EndIf

   MapArray(x,y,lay) = block
   ;DrawCanvas(x,y)

  Next i
  
  UpdateLayer()
      
EndProcedure


Procedure InsertLayer()
 
 If FrontMode : ProcedureReturn : EndIf
 CurrentLayer = GetGadgetState(#Spin4)
 
 za + 1 : ReDim MapArray(xa,ya,za)
 
 If CurrentLayer < za-1 
  
  For i = za-1 To CurrentLayer Step -1
   DuplicateLayer(i,i+1)
  Next i
 
 For y = 0 To ya-1
 For x = 0 To xa-1
  MapArray(x,y,CurrentLayer+1) = 0
 Next x
 Next y
 
 EndIf
 
 SetGadgetAttribute(#Spin4, #PB_Spin_Maximum, za)
 SetGadgetState(#Spin4, CurrentLayer+1)
 SetGadgetState(#Spin3, za)
 
 UpdateLayer()
 
EndProcedure


Procedure RemoveLayer()
 
 CurrentLayer = GetGadgetState(#Spin4)
 If FrontMode : ProcedureReturn : EndIf
 
  If CurrentLayer < za
  For i = CurrentLayer To za-1
   DuplicateLayer(i+1,i)
  Next i
  EndIf
 
 za - 1 : ReDim MapArray(xa,ya,za)
 SetGadgetAttribute(#Spin4, #PB_Spin_Maximum, za)
 SetGadgetState(#Spin3, za)
 SetGadgetState(#Spin4,CurrentLayer)

 UpdateLayer()
 
EndProcedure


Procedure.l RotateImage(source,angle.f,scale)
 
  s.f=Sin(6.28318531/3600*angle):c.f=Cos(6.28318531/3600*angle)
  
  bitmap=CreateCompatibleBitmap_(GetDC_(0),ImageWidth(source),ImageHeight(source))
  dc=CreateCompatibleDC_(GetDC_(0))
  obj=SelectObject_(dc,bitmap)
  sid=ImageOutput(source)
  workdc=StartDrawing(sid)
  BitBlt_(dc,0,0,ImageWidth(source),ImageHeight(source),workdc,0,0,13369376)
  ;transcolor=Point(SpriteWidth(source)-1,0);<-----transparente farbe oberes-rechtes pixel im sourcesprite
  StopDrawing()
  
  mx=ImageWidth(source)/2:my=ImageHeight(source)/2
  radius.f=Sqr(mx*mx + my*my)+1
  If scale=0
   target = CreateImage(#PB_Any,ImageWidth(source),ImageHeight(source))
   cl=1
   mx2=mx:my2=my
  Else
   target = CreateImage(#PB_Any,radius*2,radius*2)
   cl=1
   mx2=radius:my2=radius:diffmx=mx2-mx:diffmy=my2-my
  EndIf
  
  max=ImageWidth(target):may=ImageHeight(target)
  sid=ImageOutput(target)
  workdc=StartDrawing(sid)
  Box(x, y, max, may,transcolor)
  For y=0 To ImageHeight(source)-1
    For x=0 To ImageWidth(source)-1
      RotateX.l = ((x - mx) * c - (y - my) * s) + mx + diffmx
      RotateY.l = ((x - mx) * s + (y - my) * c) + my + diffmy
      If RotateX>0 And RotateX<max-1 And RotateY>0 And RotateY<may-1
        color=GetPixel_(dc,x,y)
        Plot(RotateX,RotateY,color)
         If angle<>0 And angle<>900 And angle<>1800 And angle<>2700 And angle<>3600
           Plot(RotateX+1,RotateY,color);<--Das ist mein wahnsinnig komplizierter
           Plot(RotateX,RotateY+1,color);<--Antialiasing-Algorythmus *lol*
         EndIf
      EndIf
    Next x
  Next y
  StopDrawing()
  DeleteObject_(bitmap):DeleteObject_(obj):DeleteDC_(dc)
  
  ProcedureReturn Target
  
EndProcedure


Procedure RotateBuilding(angle)
 
 For i = 0 To za 
  RotateLayer(i, angle)
 Next i
 UpdateLayer()

EndProcedure


Procedure RotateLayer(layer, angle)

;Layer + Block lesen
lay   = layer
SelectElement(BlockImages(),GetGadgetState(#ComboBox_Blocks))


;Bild erstellen 
Picture = CreateImage(#PB_Any, xa, ya)
StartDrawing(ImageOutput(Picture))

For y = 0 To ya-1
For x = 0 To xa-1
 Select MapArray(x+1,y+1,lay)
 Case 0 : Color = $0
 Case 1 : color = $45EA45
 Case 2 : color = $003755
 Case 3 : color = $71B6DA
 Case 4 : color = $15394C
 Case 5 : color = $00DBDE
 Case 6 : color = $EAE045
 EndSelect
 Plot(x,y,color)
Next x
Next y
StopDrawing()

;Bild rotieren
Target = RotateImage(Picture, angle, 0)

;Bildaten ins Array zurckkopieren
StartDrawing(ImageOutput(Target))
For y = 0 To ya-1
For x = 0 To xa-1
 Select Point(x,y)
 Case $0      : MapArray(x+1,y+1,lay) = 0
 Case $45EA45 : MapArray(x+1,y+1,lay) = 1
 Case $003755 : MapArray(x+1,y+1,lay) = 2
 Case $71B6DA : MapArray(x+1,y+1,lay) = 3
 Case $15394C : MapArray(x+1,y+1,lay) = 4
 Case $00DBDE : MapArray(x+1,y+1,lay) = 5
 Case $EAE045 : MapArray(x+1,y+1,lay) = 6
 EndSelect
Next x
Next y
StopDrawing()

;Updaten
FreeImage(Picture)
FreeImage(Target)

EndProcedure


Procedure Maximize(windowid, message, wparam, lparam)
  
 If message = #WM_SIZE And ((wparam = #SIZE_MAXIMIZED) Or (wparam = #SIZE_RESTORED))
  ResizeGadget(#ScrollArea, #PB_Ignore, ToolSize, WindowWidth(#Window), WindowHeight(#Window)-ToolSize)
  ;x = (GadgetWidth(#ScrollArea)-GadgetWidth(#Canvas)) / 2
  ;y = (GadgetHeight(#ScrollArea)-GadgetHeight(#Canvas)) / 2
  ;ResizeGadget(#Canvas, x,y,#PB_Ignore,#PB_Ignore)
 EndIf
 
 ProcedureReturn #PB_ProcessPureBasicEvents
 
EndProcedure


Procedure ErrorHandler()
 
 ;//////////////////////////////////////// Errorhandler : gibt eine Fehlermeldung aus und beendet das Programm //////////////////////////////////
 
 errormessage.s = ErrorMessage()
 MessageRequester("Error", errormessage + " Line: " +  Str(ErrorLine()))
 End
   
EndProcedure


OnErrorCall(@ErrorHandler())
OpenWin()
EmptyCanvas()

Repeat
   
  Event = WaitWindowEvent()
  Select Event
     Case 522 ;MouseWheel
     wheel = EventwParam() : OldLayer = GetGadgetState(#Spin4)
     If wheel > 0  : SetGadgetState(#spin4,GetGadgetState(#Spin4) + 1) : EndIf
     If wheel < 0  : SetGadgetState(#spin4,GetGadgetState(#Spin4) - 1) : EndIf
     UpdateLayer()
    Case #WM_MBUTTONDOWN;#WM_RBUTTONDBLCLK;#WM_RBUTTONDOWN 
      DisplayPopupMenu(#Menu, WindowID(#Window))
    Case #PB_Event_Menu
      PopUpMenu()
    Case #PB_Event_Gadget
      Select EventGadget()
        Case #Canvas
         SetBlock()
        Case #Button_Load
         LoadBuilding() 
        Case #Button_Save
         SaveBuilding(0) 
        Case #Spin4
         OldLayer = GetGadgetState(#Spin4)
         UpdateLayer()
        Case #ComboBox_Blocks
        Case #Spin1
        Case #Spin2
        Case #Spin3
        Case #Button_Create
         EmptyCanvas()
      EndSelect
    Case #PB_Event_CloseWindow
      Select EventWindow()
        Case #Window
          CloseWindow(#Window)
          Break
      EndSelect
  EndSelect
ForEver

DataSection
 Terrain:
 IncludeBinary "terrain.png"
 Base:
 IncludeBinary "base.png"
 Air:
 IncludeBinary "air.png"
 Red:
 IncludeBinary "red.png"
EndDataSection

; IDE Options = PureBasic 5.10 Beta 3 (Windows - x86)
; CursorPosition = 84
; FirstLine = 54
; Folding = ----
; EnableXP
; EnableOnError
; UseIcon = icon.ico
; Executable = C:\Users\Alexander\Desktop\CreepyBlocks\CreepyBlocks.exe