
XIncludeFile "ComboEx.pbi"
;XIncludeFile "3DPreview.pbi"



Enumeration
  #Window
  #ScrollArea
  #Canvas
  #Button_Load
  #Button_Save
  #Button_Create
  #Spin1
  #Spin2
  #Spin3
  #Spin4
  #ComboBox_Blocks
  #Sprite
  #Air
  #Base
  #Menu
EndEnumeration

Declare OpenWin()
Declare EmptyCanvas()
Declare DrawCanvas(mx,my)
Declare SetBlock()
Declare ChangeLayer()
Declare SaveBuilding(temp)
Declare LoadBuilding()
Declare PopUpMenu()
Declare DuplicateLayer(L1, L2)
Declare FillArray(xa, ya, za)
Declare Maximize(windowid, message, wparam, lparam)
Declare ButtonProc(hWnd, msg, wparam, lparam)
Declare Fill()

Global Event, ToolSize = 90
Global xa,ya,za, xs, ys
Global mx,my

Procedure OpenWin()
  
  If OpenWindow(#Window, 0, 0, 938, 740, "CreepyBlocks  0/0  Length: 0", #PB_Window_SystemMenu|#PB_Window_MinimizeGadget| #PB_Window_MaximizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
   ButtonGadget(#Button_Load, 10, 20, 80, 30, "Load")
   ButtonGadget(#Button_Save, 110, 20, 80, 30, "Save")
   SpinGadget(#Spin1, 210, 20, 80, 30, 1, 100, #PB_Spin_Numeric) : SetGadgetText(#Spin1, "29")
   SpinGadget(#Spin2, 300, 20, 80, 30, 1, 100, #PB_Spin_Numeric) : SetGadgetText(#Spin2, "20")
   SpinGadget(#Spin3, 390, 20, 70, 30, 1, 100, #PB_Spin_Numeric) : SetGadgetText(#Spin3, "8")
   SpinGadget(#Spin4, 660, 16, 60, 45, 0, 100, #PB_Spin_Numeric) : SetGadgetText(#Spin4, "8")
   ButtonGadget(#Button_Create, 480, 20, 90, 31, "New")
   ;ButtonGadget(#LayerButton, 690, 17, 40, 40, "0")
   ComboBoxExGadget(#ComboBox_Blocks, 755, 18,170, 332, 0, 32, 32)
   ScrollAreaGadget(#ScrollArea, 0, 70, 960, 660, 956, 744, 10, #PB_ScrollArea_Raised)
   CanvasGadget(#Canvas, 0, 70, 960, 660,#PB_Canvas_Border | #PB_Canvas_Keyboard |#PB_Canvas_DrawFocus)
   CloseGadgetList()
  EndIf
  
  CreatePopupMenu(#Menu)     
  MenuItem(1, "Copy Layer")     
  MenuItem(2, "Paste Layer")      
  MenuItem(3, "Fill Area")
  MenuItem(4, "Preview 3D")
  CloseSubMenu()

  LoadFont(0,"Arial",12)
  SetGadgetFont(#Button_Load,FontID(0))
  SetGadgetFont(#Button_Save,FontID(0))
  SetGadgetFont(#Button_Create,FontID(0))
  
  SetGadgetFont(#Spin1,FontID(0))
  SetGadgetFont(#Spin2,FontID(0))
  SetGadgetFont(#Spin3,FontID(0))
  SetGadgetFont(#Spin4,FontID(0))
  
  SetWindowCallback(@Maximize())
  
  UsePNGImageDecoder() : CatchImage(#Sprite, ?Terrain) : Global NewList BlockImages.l()
  SpriteX = ImageWidth(#Sprite) / 16 : SpriteY = ImageHeight(#Sprite) / 16
  
  Global Dim Stuff.s(6)
  Stuff(0) = "Air"
  Stuff(1) = "Base"
  Stuff(2) = "Dirt"
  Stuff(3) = "Wood"
  Stuff(4) = "Logs"
  Stuff(5) = "Torch"
  Stuff(6) = "Glass"
  
  CatchImage(#Air,  ?Air)
  ResizeImage(#Air, 32,32,32)
  AddElement(BlockImages()) : BlockImages() = ImageID(#Air)
  AddGadgetItem(#ComboBox_Blocks, -1 , "Air" , ImageID(#Air))
  
  CatchImage(#Base, ?Base)
  ResizeImage(#Base, 32,32,32)
  AddElement(BlockImages()) : BlockImages() = ImageID(#Base)
  AddGadgetItem(#ComboBox_Blocks, -1 , "Base" , ImageID(#Base))
  
  SetGadgetState(#ComboBox_Blocks, 0)
  
  ci = 1
   For iy = 0 To SpriteY -1
   For ix = 0 To SpriteX -1
    AddElement(BlockImages())
    buf=GrabImage(#Sprite, #PB_Any, ix * 16, iy * 16, 16 , 16)
    ResizeImage(buf, 32,32,32)
    BlockImages() = ImageID(buf) : ci+1
    AddGadgetItem(#ComboBox_Blocks, -1 , Stuff(ci) , BlockImages())
   Next ix
  Next iy
  
  
EndProcedure


Procedure EmptyCanvas()
  
 xa = GetGadgetState(#Spin1)
 ya = GetGadgetState(#Spin2)
 za = GetGadgetState(#Spin3) 
 
 Global Dim MapArray(xa, ya, za)
 
 xs = xa * ImageWidth(#Air)  + 5
 ys = ya * ImageHeight(#Air) + 5
 
 ScrollAreaGadget(#ScrollArea, 0, ToolSize, WindowWidth(#Window), WindowHeight(#Window)-ToolSize, xs, ys, #PB_ScrollArea_Raised)
 CanvasGadget(#Canvas, 0, 0, xs, ys, #PB_Canvas_Border)
 CloseGadgetList()
 
;  x = (GadgetWidth(#ScrollArea)-GadgetWidth(#Canvas)) / 2
;  y = (GadgetHeight(#ScrollArea)-GadgetHeight(#Canvas)) / 2
;  ResizeGadget(#Canvas, x,y,#PB_Ignore,#PB_Ignore)
 
 FillArray(xa,ya,za)
 
 StartDrawing(CanvasOutput(#Canvas))
 For iy = 0 To ya-1
   For ix = 0 To xa-1
    SelectElement(BlockImages(),1)
    DrawImage(BlockImages(),ix * ImageWidth(#Air), iy * ImageHeight(#Air)) 
   Next ix
  Next iy
 StopDrawing()
  
 SetGadgetAttribute(#Spin4, #PB_Spin_Maximum, za) : SetGadgetState(#Spin4,0)
 SetGadgetState(#ComboBox_Blocks,2)
 
EndProcedure


Procedure DrawCanvas(mx,my)
 
 lay = GetGadgetState(#Spin4)
  
 StartDrawing(CanvasOutput(#Canvas)) 
 SelectElement(BlockImages(), MapArray(mx,my,lay))
 DrawImage(BlockImages(),((mx-1) * ImageWidth(#Air)), ((my-1) * ImageHeight(#Air)))
 StopDrawing()
  
EndProcedure


Procedure SetBlock()
 
 Static oldx,oldy, tit$ 
 SetActiveGadget(#ScrollArea)
 
 mx = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseX)  / ImageWidth(#Air)  +1) 
 my = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseY)  / ImageHeight(#Air) +1)
 If my = oldy : tit$ = "  Length: " + Str(mx-oldx+1) : Else : tit$ = "  Length: " + Str(my-oldy+1) : EndIf 
 
 SetWindowTitle(#Window, "Creepy Blocks  " + Str(mx) + "/" + Str(my) + tit$)
 
  If GetGadgetAttribute(#Canvas, #PB_Canvas_Modifiers) & #PB_Canvas_Control And EventType() = #PB_EventType_LeftButtonDown 
   If Not (mx < 0 Or mx > xa Or my < 0 Or my > ya)
    lay = GetGadgetState(#Spin4)
    block = MapArray(mx,my,lay) 
    SetGadgetState(#ComboBox_Blocks,block)
    SetActiveGadget(#ScrollArea)
    ProcedureReturn
    EndIf
  EndIf  
           
 If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Canvas, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
  If Not (mx < 0 Or mx > xa Or my < 0 Or my > ya)
  lay   = GetGadgetState(#Spin4)
  block = GetGadgetState(#ComboBox_Blocks) 
  MapArray(mx,my,lay) = block
  DrawCanvas(mx,my)
  OldX = mx : OldY = my
  EndIf
 EndIf
 
 If EventType() = #PB_EventType_RightButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Canvas, #PB_Canvas_Buttons) & #PB_Canvas_RightButton)
  mx = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseX)  / ImageWidth(#Air)  +1) 
  my = Int(GetGadgetAttribute(#Canvas, #PB_Canvas_MouseY)  / ImageHeight(#Air) +1)
  If Not (mx < 0 Or mx > xa Or my < 0 Or my > ya)
  lay   = GetGadgetState(#Spin4)
  If lay = 0 : block = 1 : Else : block = 0 : EndIf
  MapArray(mx,my,lay) = block
  DrawCanvas(mx,my)
  EndIf
 EndIf

    
EndProcedure  


Procedure ChangeLayer()
  
  StartDrawing(CanvasOutput(#Canvas))
  For iy = 0 To ya-1
    For ix = 0 To xa-1
     SelectElement(BlockImages(), MapArray(ix+1,iy+1,GetGadgetState(#Spin4)))
     DrawImage(BlockImages(),ix * ImageWidth(#Air), iy * ImageHeight(#Air)) 
    Next ix
  Next iy
 StopDrawing()
 
 SetActiveGadget(#ScrollArea)
   
EndProcedure


Procedure LoadBuilding()
  
 File$ = OpenFileRequester("Load Building ", GetCurrentDirectory() , "txt (*.txt) | *.txt", 0)
 
 If ReadFile(0, File$) 
   
  MapSize$ = ReadString(0)  
  Dummy$   = ReadString(0)
  xa = Val(StringField(MapSize$, 1, "x"))     : SetGadgetText(#Spin1, Str(xa))
  ya = Val(StringField(MapSize$, 2, "x"))     : SetGadgetText(#Spin2, Str(ya))
  za = Val(StringField(MapSize$, 3, "x"))     : SetGadgetText(#Spin3, Str(za))
  
  Global Dim MapArray(xa, ya, za) 
  
  While ii < za + 1       
  Layer$ = ReadString(0) 
  Repeat
    iy + 1
    line$ = ReadString(0)
    If Line$ = Chr(10) Or Len(Line$) <> xa
      iy = 0 : ii + 1
      Break 
    Else
     For ix = 1 To Len(Line$) 
       Select Mid(Line$,ix,1)
       Case "D"
       MapArray(ix,iy,ii) = 2
       Case "W"
       MapArray(ix,iy,ii) = 3 
       Case "L"
       MapArray(ix,iy,ii) = 4 
       Case "T"
       MapArray(ix,iy,ii) = 5 
       Case "G"
       MapArray(ix,iy,ii) = 6
       Case " "
       MapArray(ix,iy,ii) = 0 
       Case "#"
       MapArray(ix,iy,ii) = 1     
       EndSelect
     Next ix
   EndIf  
 ForEver
 Wend
  CloseFile(0)             
 Else
  ProcedureReturn
  ;MessageRequester("Error","Could Not Open File !")
 EndIf
 
xs = xa * ImageWidth(#Air)  + 5 
ys = ya * ImageHeight(#Air) + 5
 
ScrollAreaGadget(#ScrollArea, 0, ToolSize, WindowWidth(#Window), WindowHeight(#Window)-ToolSize, xs, ys, #PB_ScrollArea_Raised)
CanvasGadget(#Canvas, 0, 0, xs, ys, #PB_Canvas_Border) 
CloseGadgetList()

SetGadgetAttribute(#Spin4, #PB_Spin_Maximum, za) : SetGadgetState(#Spin4,0)
ChangeLayer() 


EndProcedure


Procedure SaveBuilding(temp)
  
 xa = GetGadgetState(#Spin1)
 ya = GetGadgetState(#Spin2)
 za = GetGadgetState(#Spin3) 
 
 If Not temp 
 File$ = SaveFileRequester("Save Building ", GetCurrentDirectory() , "txt (*.txt) | *.txt", 1)
 If Not GetExtensionPart(File$) = "txt" : File$ = File$ + ".txt" : EndIf
 Else : File$ = "preview.tmp"
 EndIf
   
 If CreateFile(0, File$)

 MapSize$ = Str(xa) + "x" + Str(ya) + "x" + Str(za)
 WriteStringN(0, MapSize$)
 WriteStringN(0, "------")
 
  While ii < za + 1    
   WriteStringN(0, "layer " + Str(ii))  
  Repeat
    iy + 1
    If iy > ya : iy = 0 : ii + 1 : WriteStringN(0,""): Break : EndIf
    For ix = 1 To xa 
      Select MapArray(ix,iy,ii)
       Case 0
       WriteAsciiCharacter(0, Asc(" "))
       Case 1
       WriteAsciiCharacter(0, Asc("#"))
       Case 2
       WriteAsciiCharacter(0, Asc("D"))
       Case 3
       WriteAsciiCharacter(0, Asc("W"))
       Case 4
       WriteAsciiCharacter(0, Asc("L"))  
       Case 5
       WriteAsciiCharacter(0, Asc("T")) 
       Case 6
       WriteAsciiCharacter(0, Asc("G"))  
       EndSelect
     Next ix
     WriteStringN(0,"")
    ForEver
 Wend
  CloseFile(0)             
 Else
  ProcedureReturn
  ;MessageRequester("Error","Could Not Open File !")
EndIf

EndProcedure


Procedure FillArray(xa, ya, za)
  
 For iz = 0 To za
  If iz = 0 : SelectElement(BlockImages(),1) : Else : SelectElement(BlockImages(),0) : EndIf
   For iy = 1 To ya
    For ix = 0 To xa
     MapArray(ix,iy,iz) = ListIndex(BlockImages()) 
    Next ix
  Next iy
 Next iz

EndProcedure


Procedure PopUpMenu()
  
Static L1 = -1,L2 = -1
  
Select EventMenu()
  Case 1
    L1 = GetGadgetState(#Spin4)
    L2 = -1
 Case 2
   L2 = GetGadgetState(#Spin4)
   If Not L1 = -1 : DuplicateLayer(L1,L2) : ChangeLayer() : EndIf
 Case 3
   Fill()
 Case 4
  SaveBuilding(1)
  RunProgram("3DPreview", "preview.tmp" , GetCurrentDirectory(), #PB_Program_Wait)
  DeleteFile("preview.tmp")
 Case 4 
 Case 5 
 Case 6 
EndSelect

EndProcedure


Procedure DuplicateLayer(L1, L2)
  
If (L1 And L2) <> 0
   
  For iy = 0 To ya
  For ix = 0 To xa
  MapArray(ix,iy,l2) = MapArray(ix, iy, l1) 
  Next ix
  Next iy
ElseIf L1=0 And L2 > 0 
  For iy = 0 To ya
  For ix = 0 To xa
  Block = MapArray(ix, iy, l1)
  If block = 1 : Block = 0 : EndIf
  MapArray(ix,iy,l2) = block
  Next ix
  Next iy
ElseIf L1 > 0 And L2 = 0
  For iy = 0 To ya
  For ix = 0 To xa
  block = MapArray(ix, iy, l1)
  If block = 0 : Block = 1 : EndIf
  MapArray(ix,iy,l2) = block
  Next ix
  Next iy
  
EndIf

EndProcedure


Procedure Fill()

lay   = GetGadgetState(#Spin4)
SelectElement(BlockImages(),GetGadgetState(#ComboBox_Blocks))

For iy = my To ya
 
If (((MapArray(mx,iy,lay) = 0) Or (MapArray(mx,iy,lay) = 1))) And (iy <= ya)

For ix = mx To xa 
 If ((MapArray(ix,iy,lay) = 0) Or (MapArray(ix,iy,lay) = 1)) : MapArray(ix,iy,lay) = ListIndex(BlockImages()) : Else : Break : EndIf
 If ix + 1 <= xa
 If ((MapArray(ix+1,iy,lay) <> 0) And (MapArray(ix+1,iy,lay))) <> 1 : Break : EndIf 
 EndIf
Next ix

For ix = mx-1 To 1 Step -1 
 If ((MapArray(ix,iy,lay) = 0) Or (MapArray(ix,iy,lay) = 1)) : MapArray(ix,iy,lay) = ListIndex(BlockImages()) : Else : Break : EndIf
 If ix - 1 > 1
 If ((MapArray(ix-1,iy,lay) <> 0) And (MapArray(ix-1,iy,lay))) <> 1 : Break : EndIf 
 EndIf
Next ix

Else : Break 
EndIf

Next iy


For iy = my-1 To 1 Step -1
 
If (((MapArray(mx,iy,lay) = 0) Or (MapArray(mx,iy,lay) = 1))) And (iy > 0)

For ix = mx To xa 
 If ((MapArray(ix,iy,lay) = 0) Or (MapArray(ix,iy,lay) = 1)) : MapArray(ix,iy,lay) = ListIndex(BlockImages()) : Else : Break : EndIf
 If ix + 1 <= xa
 If ((MapArray(ix+1,iy,lay) <> 0) And (MapArray(ix+1,iy,lay))) <> 1 : Break : EndIf 
 EndIf
Next ix

For ix = mx-1 To 1 Step -1 
 If ((MapArray(ix,iy,lay) = 0) Or (MapArray(ix,iy,lay) = 1)) : MapArray(ix,iy,lay) = ListIndex(BlockImages()) : Else : Break : EndIf
 If ix - 1 > 1
 If ((MapArray(ix-1,iy,lay) <> 0) And (MapArray(ix-1,iy,lay))) <> 1 : Break : EndIf 
 EndIf
Next ix

Else : Break 
EndIf

Next iy

ChangeLayer()

EndProcedure


Procedure Maximize(windowid, message, wparam, lparam)
  
 If message = #WM_SIZE And ((wparam = #SIZE_MAXIMIZED) Or (wparam = #SIZE_RESTORED))
  ResizeGadget(#ScrollArea, #PB_Ignore, ToolSize, WindowWidth(#Window), WindowHeight(#Window)-ToolSize)
;    x = (GadgetWidth(#ScrollArea)-GadgetWidth(#Canvas)) / 2
;    y = (GadgetHeight(#ScrollArea)-GadgetHeight(#Canvas)) / 2
;    ResizeGadget(#Canvas, x,y,#PB_Ignore,#PB_Ignore)
 EndIf

 ProcedureReturn #PB_ProcessPureBasicEvents
 
EndProcedure



OpenWin()
EmptyCanvas()

Repeat
   
  Event = WaitWindowEvent()
  Select Event
    Case #WM_MBUTTONDOWN;#WM_RBUTTONDBLCLK;#WM_RBUTTONDOWN 
      DisplayPopupMenu(#Menu, WindowID(#Window))
    Case #PB_Event_Menu
      PopUpMenu()
    Case #PB_Event_Gadget
      Select EventGadget()
        Case #Canvas
         SetBlock()
        Case #Button_Load
         LoadBuilding() 
        Case #Button_Save
         SaveBuilding(0) 
        Case #Spin4
         ChangeLayer()
        Case #ComboBox_Blocks
        Case #Spin1
        Case #Spin2
        Case #Spin3
        Case #Button_Create
         EmptyCanvas()
      EndSelect
    Case #PB_Event_CloseWindow
      Select EventWindow()
        Case #Window
          CloseWindow(#Window)
          Break
      EndSelect
  EndSelect
ForEver

DataSection
 Terrain:
 IncludeBinary "terrain.png"
 Base:
 IncludeBinary "base.png"
 Air:
 IncludeBinary "air.png"
EndDataSection

; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 179
; FirstLine = 151
; Folding = Lg-
; EnableXP
; UseIcon = icon.ico
; Executable = CreepyBlocks.exe
; SubSystem = dx9